data_panama<-read.csv( "C:/Users/DELL/Desktop/ClaseCuatro/Panama/brutas_Panama.csv")

data_panama$logpobtot <- log(data_panama$pobtot)
data_panama$ldensidad <- log(data_panama$densidad)

data_panama$Mldensidad= max(data_panama$ldensidad) 
data_panama$mldensidad=min(data_panama$ldensidad)
data_panama$xldensidad=  (data_panama$Mldensidad - data_panama$ldensidad)/(data_panama$Mldensidad-data_panama$mldensidad)


data_panama$Mlogpobtot <- max(data_panama$logpobtot) 
data_panama$mlogpobtot=min(data_panama$logpobtot)
data_panama$xlogpobtot= (data_panama$Mlogpobtot - data_panama$logpobtot)/(data_panama$Mlogpobtot-data_panama$mlogpobtot)

data_panama$Mpersuelurb= max(data_panama$persuel_urb)
data_panama$mpersuelurb= min(data_panama$persuel_urb)
data_panama$xpersuelurb=(data_panama$Mpersuelurb-data_panama$persuel_urb)/(data_panama$Mpersuelurb-data_panama$mpersuelurb) 

data_panama$Mhubdist_min= max(data_panama$promdis_mun)
data_panama$mhubdist_min= min(data_panama$promdis_mun)
data_panama$xhubdist_min= 1-(data_panama$Mhubdist_min - data_panama$promdis_mun) /(data_panama$Mhubdist_min-data_panama$mhubdist_min)


data_panama$IRR = ((data_panama$xlogpobtot^.25)*(data_panama$xldensidad^.25)*(data_panama$xpersuelurb^.25)*(data_panama$xhubdist_min^.25))


#Se añaden Leading Zeros para obtener ID simialres a nuestro shapefiles
data_panama$COD_PROV <- sprintf("%02d", data_panama$prov_id)
data_panama$COD_DISTRI <- sprintf("%02d", data_panama$dist_id)
data_panama$COD_CORREG <- sprintf("%02d", data_panama$corr_id)

#Se genera el CODIGO unico por corregimiento
data_panama$CODIGO = paste(data_panama$COD_PROV,data_panama$COD_DISTRI, data_panama$COD_CORREG,sep="")
data_panama$CODIGO <-as.factor(data_panama$CODIGO)


# Leemos el shapefile con rgdal library. 

library(rgdal)
library(raster)

data.shape<-readOGR(dsn="C:/Users/DELL/Desktop/ClaseCuatro/Panama/shp", layer="Corregimientos_Panama")


# merge a partir de la variable CODIGO en comun entre los dos objetos
m <- merge(data.shape, data_panama, by = c("CODIGO"))

# Tambien se puede guardar como Shapefile
shapefile(m, "C:/Users/DELL/Desktop/ClaseCuatro/Panama/shp/Panama_merged.shp")


#Herramienta LEAFLET para generar mapa interactivos
library(leaflet)

bins <- c(0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1)
pal <- colorBin("viridis", domain = m$IRR, bins = bins, reverse = TRUE)

#1er Mapa
map_categIRR <- leaflet(m) %>%
  addTiles() %>%
  addPolygons( weight = 0.1,  stroke = TRUE, 
               opacity = 1.0, fillOpacity = 0.8,
               fillColor = ~pal(IRR),  color = "black"  )

map_categIRR


#2do Mapa
map_categIRR <- leaflet(m) %>%
     addTiles() %>%
     addPolygons( weight = 0.1, smoothFactor = 1, stroke = TRUE, 
                                   opacity = 1.0, fillOpacity = 0.8,
                                   fillColor = ~pal(IRR),  color = "black",
                                   highlightOptions = highlightOptions(color = "white", weight = 0.8,
                                                bringToFront = TRUE),  
                  label =paste0( "Corregimiento:" , m$corr_nomb , "  " , "IRR:", m$IRR )) %>%
     addLegend("bottomright", pal = pal, values = bins,
                             title = "IRR (2010)",
                             labFormat = labelFormat(prefix = ""),
                             opacity = 1
                   )

map_categIRR
